from load_zivid_file import load_zdf
from matplotlib import pyplot as plt
import numpy as np
from pose_estimation import segment_pcd, remove_zeros
from open3d import *



if __name__ == '__main__':
    # get input files
    pcd, rgb, depth = load_zdf('C:/Users/cpascheh/Desktop/workspace/rgb/zivid_data/02062019/pcd1.zdf')
    out_mask = np.load('C:/Users/cpascheh/Desktop/master-plots/bin_seg/mask1.npy')
    pcd[np.isnan(pcd[:, :, 2])] = 0
    pcd = pcd[:, :, [0, 1, 2, 4, 5, 6]]

    # pcd = np.load('C:/Users/cpascheh/Desktop/workspace/rgb/sim_data/pcds/pcd205.npy')
    # rgb = pcd[:, :, 3:]

    plt.imshow(rgb)
    plt.title("RGB image")
    plt.xlabel('Pixels')
    plt.ylabel('Pixels')
    # plt.savefig('C:/Users/cpascheh/Desktop/master-plots/bin_seg/rgb4.png')
    #plt.show()

    out_mask = out_mask.squeeze()
    plt.imshow(out_mask)
    plt.title("Predicted mask")
    plt.xlabel('Pixels')
    plt.ylabel('Pixels')
    # plt.savefig('C:/Users/cpascheh/Desktop/master-plots/bin_seg/pred_mask4.png')
    #plt.show()

    seg_pcd = segment_pcd(pcd, out_mask)
    #seg_pcd = remove_zeros(seg_pcd)

    pts = seg_pcd.reshape(-1, 6)
    seg = PointCloud()
    seg.points = Vector3dVector(pts[:, :3])
    seg.colors = Vector3dVector(pts[:, 3:] / 255)
    draw_geometries([seg])

    # pts = seg_pcd.squeeze()
    # seg = PointCloud()
    # seg.points = Vector3dVector(pts[:, :3])
    # seg.colors = Vector3dVector(seg_pcd[:, :, 3:].squeeze() / 255)
    # draw_geometries([seg])
